/*
 *  Copyright 2019-2020 Zheng Jie
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package com.youchain.modules.quartz.task;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.youchain.annotation.AnonymousAccess;
import com.youchain.basicdata.domain.BillType;
import com.youchain.basicdata.domain.Point;
import com.youchain.basicdata.repository.BillTypeRepository;
import com.youchain.basicdata.repository.PointRepository;
import com.youchain.businessdata.domain.AgvTask;
import com.youchain.businessdata.domain.Asn;
import com.youchain.businessdata.repository.AgvTaskRepository;
import com.youchain.businessdata.repository.AsnRepository;
import com.youchain.businessdata.service.AgvTaskService;
import com.youchain.businessdata.service.AsnService;
import com.youchain.exception.handler.ApiResult;
import com.youchain.utils.BizStatus;
import lombok.extern.slf4j.Slf4j;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.*;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;


/**
 * 测试用
 * @author Liu Xue
 * @date 2019-01-08
 */
@Slf4j
@Service
@RestController
@RequestMapping("/api/test")
public class TestTask {
    @Autowired
    private AgvTaskRepository agvTaskRepository;
    @Autowired
    private PointRepository pointRepository;
    @Autowired
    private AsnRepository asnRepository;
    @Autowired
    private AsnService asnService;
    @Autowired
    private  AgvTaskService agvTaskService;

    private static final int MAX_TASK_COUNT = 4;
    private static final long TIMEOUT_MS = 600000; // 10分钟，以毫秒为单位
    private long lastTaskTime = System.currentTimeMillis();
    /** 占用库位*/
    /*@PostMapping("/startAsn")
    @AnonymousAccess*/
    @Transactional
    public ResponseEntity<Object> startAsn(String req){
        JSONArray data=new JSONArray();
        JSONObject jsonObject=JSONObject.parseObject(req);
        JSONArray billTypeArray=jsonObject.getJSONArray("billType");
        for (int i = 0; i < billTypeArray.size(); i++) {
            List<Asn> asnList=asnRepository.findByBillType(billTypeArray.getString(i));
            for (int j = 0; j < asnList.size(); j++) {
                Asn asn=asnList.get(j);
                ApiResult apiResult = asnService.startAsn(asn);
                data.add(apiResult);
            }
        }
        ApiResult apiResult=ApiResult.fail(200,"操作成功",null);
        return new ResponseEntity<>(apiResult, HttpStatus.valueOf(apiResult.getStatus()));
    }
    @PostMapping("/asnTask")
    @AnonymousAccess
    public ResponseEntity<Object> asnTask(){
        /*List<Point> pointList = pointRepository.findByAreaCode("RKGZ");
        for (int i = 0; i < pointList.size(); i++) {
            Point point =pointList.get(i);
            if (point.getStorageType()!=null&&point.getStorageType().length()>0){
                System.out.println("生成入库搬运任务");
            }
         }*/
        System.out.println("入库任务");
        ApiResult apiResult = agvTaskService.addAgvAsn();
        return new ResponseEntity<>(apiResult, HttpStatus.valueOf(apiResult.getStatus()));
    }
}
